#include "testlib.h"
#include <cassert>

#define all(a) (a).begin(), (a).end()
#define repeat(a) for (int i_step = 0; i_step < a; ++i_step)
 
using namespace std;
 
/*
gen test with
sounds ab, abab, ababab, abababab, ...
sounds ba, baba, bababa, babababa, ...
text - abababababababab...
*/
 
const int GROUPS = 10;
const int MAX_LEN_T[GROUPS + 1] = {500'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 6000, 200'000, 500'000};
const int MAX_S[GROUPS + 1] = {1'000'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 200'000, 400'000, 1'000'000};
const int MAX_Q[GROUPS + 1] = {300'000, 500, 6000, 200'000, 200'000, 200'000, 200'000, 6000, 6000, 200'000, 300'000};
const bool BD_T[GROUPS + 1] = {0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0};
const bool AC_1[GROUPS + 1] = {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0};

int get_id(int x, vector <int> & dsu) {
    if (dsu[x] == x) return x;
    else return dsu[x] = get_id(dsu[x], dsu);
}
 
int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int group = opt<int>("gr");
    int type_req = opt<int>("type_req");

    assert(!BD_T[group]);
 
    string t = "";

    repeat(MAX_LEN_T[group] / 2) {
        t.push_back('a');
        t.push_back('b');
    }
 
    vector <string> sounds;
    sounds.push_back("ab");
    sounds.push_back("ba");
 
    int S = 4;
 
    while (S + 4 * (int)sounds.back().size() <= MAX_S[group]) {
        sounds.push_back(sounds[sounds.size() - 2] + sounds[sounds.size() - 2]);
        sounds.push_back(sounds[sounds.size() - 2] + sounds[sounds.size() - 2]);
        S += 2 * (int)sounds.back().size();
    }
    shuffle(all(sounds));
 
    println(t);
    
    int n = sounds.size();
    vector <pair <int, int>> input_pairs;

    if (AC_1[group]) {
        int pr = -1;
        for (int i = 0; i < n; ++i) {
            if (sounds[i][0] == 'a') {
                if (pr != -1) {
                    if (rnd.next(0, 1))
                        input_pairs.push_back({pr, 27 + i});
                    else
                        input_pairs.push_back({27 + i, pr});
                }
                pr = 27 + i;
            }
        }
    }

    vector <vector <int>> req;
    if (AC_1[group]) {
        for (int len = 4; len <= MAX_LEN_T[group] && req.size() < MAX_Q[group]; len *= 2) {
            for (int len2 = 2; 2 * len + len2 <= MAX_LEN_T[group] && req.size() < MAX_Q[group]; len2 *= 2) {
                req.push_back({1, len + len2, 1, 2 * len + len2});
            }
        }
    } else {
        if (type_req == 0) {
            for (int len = 1; len <= MAX_LEN_T[group] && req.size() < MAX_Q[group]; ++len) {
                req.push_back({1, len, MAX_LEN_T[group] - len + 1, MAX_LEN_T[group]});
            }
        } else if (type_req == 1) {
            for (int len = 2; len <= MAX_LEN_T[group] && req.size() < MAX_Q[group]; len += 2) {
                req.push_back({1, len, MAX_LEN_T[group] - len + 1, MAX_LEN_T[group]});
            }
            for (int len = 2; len < MAX_LEN_T[group] && req.size() < MAX_Q[group]; len += 2) {
                req.push_back({2, len + 1, MAX_LEN_T[group] - len, MAX_LEN_T[group] - 1});
            }
        }
    }

    while (req.size() < MAX_Q[group]) {
        if (AC_1[group]) {
            while(req.size() < MAX_Q[group]) {
                int a = 1;
                int b = rnd.next(a, (int)t.size());
                int c = 1;
                int d = rnd.next(c, (int)t.size());
                req.push_back({a, b, c, d});
            }
        } else {
            while(req.size() < MAX_Q[group]) {
                int a = rnd.next(1, (int)t.size());
                int b = rnd.next(a, (int)t.size());
                int c = rnd.next(1, (int)t.size());
                int d = rnd.next(c, (int)t.size());
                req.push_back({a, b, c, d});
            }
        }
    }
    
    println(n, input_pairs.size());
    for (auto & s : sounds) {
        println(s);
    }
    shuffle(all(input_pairs));
    for (auto & p : input_pairs) {
        println(p.first, p.second);
    }
    
    println(req.size());
    shuffle(all(req));
    for (auto & v : req) {
        println(v);
    }
}
