#include "testlib.h"

#define all(a) (a).begin(), (a).end()
 
using namespace std;
 
/*
gen test with strings divided into blocks
test - 3 blocks, some substrings in block are sounds
blocks size is blk, 2*blk, blk
*/
 
const int GROUPS = 10;
const int MAX_LEN_T[GROUPS + 1] = {500'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 6000, 200'000, 500'000};
const int MAX_S[GROUPS + 1] = {1'000'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 200'000, 400'000, 1'000'000};
const int MAX_Q[GROUPS + 1] = {300'000, 500, 6000, 200'000, 200'000, 200'000, 200'000, 6000, 6000, 200'000, 300'000};
const bool BD_T[GROUPS + 1] = {0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0};
const bool AC_1[GROUPS + 1] = {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0};

int get_id(int x, vector <int> & dsu) {
    if (dsu[x] == x) return x;
    else return dsu[x] = get_id(dsu[x], dsu);
}
 
int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int group = opt<int>("gr");
    int blk = opt<int>("blk");
 
    string t = "";
 
    map <string, int> id;
    map <string, char> with;
 
    for (char x = 'a'; x <= 'z'; ++x) {
        id[string{x}] = x - 'a' + 1;
    }
 
    vector <string> sounds;
 
    int S = 0;
 
    vector <pair <int, int>> pairs;
 
    vector <vector <int>> req;
 
    while (true) {
        string test;
 
        for (int i = 0; i < 4 * blk; ++i) {
            test.push_back('a' + rnd.next(1, 25));
        }
 
        if (t.size() + test.size() > MAX_LEN_T[group]) {
            break;
        }
 
        int new_S = 0;
 
        vector <string> new_sounds;
 
        for (int len = 2; len <= blk; ++len) {
            string s = test.substr(blk - len, len);
            if (id[s] == 0) {
                new_sounds.push_back(s);
                id[s] = new_sounds.size() + sounds.size() + 26;
                new_S += s.size();
                with[s] = (char)('a' + rnd.next(0, 25));
            }
        }
        {
            string s = test.substr(blk, 2*blk);
            if (id[s] == 0) {
                new_sounds.push_back(s);
                id[s] = new_sounds.size() + sounds.size() + 26;
                new_S += s.size();
            }
        }
        for (int len = 2; len <= blk; ++len) {
            string s = test.substr(3 * blk, len);
            if (id[s] == 0) {
                new_sounds.push_back(s);
                id[s] = new_sounds.size() + sounds.size() + 26;
                new_S += s.size();
                with[s] = (char)('a' + rnd.next(0, 25));
            }
        }
 
        if (S + new_S > MAX_S[group]) {
            break;
        }
 
        vector <pair <int, int>> new_pairs;
        new_pairs.push_back({1, id[test.substr(blk, 2*blk)]});
        vector <vector <int>> new_req;
        for (int l = 0; l < blk - 1; ++l) {
            if (t.size() + test.size() + 3 > MAX_LEN_T[group]) {
                break;
            }
            if (req.size() + new_req.size() + 1 > MAX_Q[group]) {
                break;
            }
            for (int r = 3 * blk + 1; r < 4 * blk; ++r) {
                if (t.size() + test.size() + 3 > MAX_LEN_T[group]) {
                    break;
                }
                if (req.size() + new_req.size() + 1 > MAX_Q[group]) {
                    break;
                }
                new_req.push_back({(int)t.size() + l + 1, (int)t.size() + r + 1, (int)t.size() + (int)test.size() + 1, (int)t.size() + (int)test.size() + 3});
                string s1 = test.substr(l, blk - l);
                string s2 = test.substr(3 * blk, r - 3 * blk + 1);
                test.push_back(with[s1]);
                test.push_back('a');
                test.push_back(with[s2]);
                new_pairs.push_back({id[string{with[s1]}], id[s1]});
                new_pairs.push_back({id[string{with[s2]}], id[s2]});
            }
        }
 
        t += test;
        S += new_S;
 
        for (auto s : new_sounds) {
            sounds.push_back(s);
        }
 
        for (auto p : new_pairs) {
            pairs.push_back(p);
        }
 
        for (auto v : new_req) {
            req.push_back(v);
        }
    }
    
    while(req.size() < MAX_Q[group]) {
        int a = rnd.next(1, (int)t.size());
        int b = rnd.next(a, (int)t.size());
        int c = rnd.next(1, (int)t.size());
        int d = rnd.next(c, (int)t.size());
        req.push_back({a, b, c, d});
    }
 
    println(t);
    
    int n = sounds.size();
    vector <pair <int, int>> input_pairs;
    vector <int> dsu(n + 27);
    for (int i = 0; i <= n + 26; ++i) {
        dsu[i] = i;
    }
 
    for (auto p : pairs) {
        int a = get_id(p.first, dsu);
        int b = get_id(p.second, dsu);
 
        if (a != b) {
            input_pairs.push_back(p);
            if (rnd.next(0, 1)) {
                dsu[a] = b;
            } else {
                dsu[b] = a;
            }
        }
    }
 
    println(n, input_pairs.size());
    for (auto & s : sounds) {
        println(s);
    }
    shuffle(all(input_pairs));
    for (auto & p : input_pairs) {
        println(p.first, p.second);
    }
    
    println(req.size());
    shuffle(all(req));
    for (auto & v : req) {
        println(v);
    }
}
