#include "testlib.h"
 
using namespace std;

/*
gen t with t.size() = len_t and ind = id_t
additional sounds get with id_s
k pairs of identical sounds are generated randomly
*/
 
int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int len_t = opt<int>("len_t");
    int id_t = opt<int>("id_t");
    int id_s = opt<int>("id_s");

    set <char> alf;
    string t;
    for (int i = 0; i < len_t; ++i) {
        t.push_back('a' + id_t % len_t);
        id_t /= len_t;
        alf.insert(t.back());
    }

    set <string> used;
    for (int i = 0; i < len_t; ++i) {
        string s;
        for (int j = i; j < len_t; ++j) {
            s.push_back(t[j]);
            if (i != j) {
                if (id_s % 2) {
                    used.insert(s);
                }
                id_s /= 2;
            }
        }
    }

    vector <string> sounds;
    for (auto s : used) {
        sounds.push_back(s);
    }

    vector <char> sym;
    for (auto c : alf) {
        sym.push_back(c);
    }
    
    int k = rnd.next(0, (int)sym.size() + (int)sounds.size() - 1);

    set <pair <int, int>> pairs;
    while (pairs.size() != k) {
        int x = rnd.next(0, (int)sounds.size() + (int)sym.size() - 1);
        int y = rnd.next(0, (int)sounds.size() + (int)sym.size() - 2);
        if (x <= y) {
            ++y;
        } else {
            swap(x, y);
        }

        if (pairs.find({x, y}) == pairs.end()) {
            pairs.insert({x, y});
        }
    }

    println(t);
    println(sounds.size(), k);
    for (auto & s : sounds) {
        println(s);
    }
    for (auto p : pairs) {
        if (p.first >= (int)sym.size()) {
            p.first += 26 - (int)sym.size();
        } else {
            ++p.first;
        }
        if (p.second >= (int)sym.size()) {
            p.second += 26 - (int)sym.size();
        } else {
            ++p.second;
        }
        println(p.first, p.second);
    }

    int q = len_t * (len_t + 1) / 2;
    println(q * q);
    for (int a = 1; a <= len_t; ++a) {
        for (int b = a; b <= len_t; ++b) {
            for (int c = 1; c <= len_t; ++c) {
                for (int d = c; d <= len_t; ++d) {
                    println(a, b, c, d);
                }
            }
        }
    }
}
