#include "testlib.h"

#define all(a) (a).begin(), (a).end()
#define repeat(a) for (int i_step = 0; i_step < a; ++i_step)
 
using namespace std;

/*
gen max remainder test
blk - size of block
sounds - string "sss..."
size of sounds is blk + 1, blk + 2, blk + 3, ...
*/

const int GROUPS = 10;
const int MAX_LEN_T[GROUPS + 1] = {500'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 6000, 200'000, 500'000};
const int MAX_S[GROUPS + 1] = {1'000'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 200'000, 400'000, 1'000'000};
const int MAX_Q[GROUPS + 1] = {300'000, 500, 6000, 200'000, 200'000, 200'000, 200'000, 6000, 6000, 200'000, 300'000};
const bool BD_T[GROUPS + 1] = {0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0};
const bool AC_1[GROUPS + 1] = {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0};

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int gr = opt<int>("gr");
    int blk = opt<int>("blk");

    string t;
    for (int i = 0; i < MAX_LEN_T[gr]; ++i) {
        t.push_back('s');
    }
    println(t);

    vector <string> sounds;
    
    int S = 0;
    string s;
    repeat(blk + 1) {
        s.push_back('s');
    }
    while (S + s.size() <= MAX_S[gr]) {
        sounds.push_back(s);
        S += s.size();
        s.push_back('s');
    }

    int n = (int)sounds.size();

    vector <pair <int, int>> pairs;

    for (int i = 1; i <= n + 26 && (int)pairs.size() < n + 25; ++i) {
        for (int j = i + 1; j <= n + 26 && (int)pairs.size() < n + 25; ++j) {
            if (rnd.next(0, 1)) {
                pairs.push_back({j, i});
            } else {
                pairs.push_back({i, j});
            }
        }
    }

    int k = (int)pairs.size();

    println(n, k);
    shuffle(all(sounds));
    for (auto & s : sounds) {
        println(s);
    }
    shuffle(all(pairs));
    for (auto & p : pairs) {
        println(p.first, p.second);
    }

    println(MAX_Q[gr]);
    int cnt_req = 0;
    for (int i = 1; i <= blk && cnt_req < MAX_Q[gr]; ++i) {
        for (int j = i; j <= blk && cnt_req < MAX_Q[gr]; ++j) {
            if (rnd.next(0, 1)) {
                println(i, j, 1, blk);
            } else {
                println(1, blk, i, j);
            }
            ++cnt_req;
        }
        if (AC_1[gr]) {
            break;
        }
    }
    repeat(MAX_Q[gr] - cnt_req) {
        println(1, blk, 1, blk);
    }
}
