#include "testlib.h"

#define all(a) (a).begin(), (a).end()
#define repeat(a) for (int i_step = 0; i_step < a; ++i_step)
 
using namespace std;

/*
gen max time test for subsounds for group "gr"
lens of sounds 1, 2, 4, 8, 16...
*/

const int GROUPS = 10;
const int MAX_LEN_T[GROUPS + 1] = {500'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 6000, 200'000, 500'000};
const int MAX_S[GROUPS + 1] = {1'000'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 200'000, 400'000, 1'000'000};
const int MAX_Q[GROUPS + 1] = {300'000, 500, 6000, 200'000, 200'000, 200'000, 200'000, 6000, 6000, 200'000, 300'000};
const bool BD_T[GROUPS + 1] = {0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0};
const bool AC_1[GROUPS + 1] = {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0};

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int gr = opt<int>("gr");
    int big_sound = opt<int>("big_sound");

    string t;
    for (int i = 0; i < MAX_LEN_T[gr]; ++i) {
        t.push_back('s');
    }
    println(t);

    vector <string> sounds;
    
    int S = 0;

    if (big_sound) {
        string s;
        repeat(min(MAX_LEN_T[gr], 2 * MAX_S[gr] / 3)) {
            s.push_back('s');
        }
        S += s.size();
        sounds.push_back(s);
    }

    S += 2;
    sounds.push_back("ss");
    while (S + (int)sounds.back().size() + 1 <= MAX_S[gr]) {
        sounds.push_back(sounds.back() + "s");
        S += (int)sounds.back().size();
    }

    int n = (int)sounds.size();

    vector <pair <int, int>> pairs;
    
    for (int i = 1; i <= n + 26 && (int)pairs.size() < n + 25; ++i) {
        for (int j = i + 1; j <= n + 26 && (int)pairs.size() < n + 25; ++j) {
            if (rnd.next(0, 1)) {
                pairs.push_back({j, i});
            } else {
                pairs.push_back({i, j});
            }
        }
    }
    
    int k = (int)pairs.size();

    println(n, k);
    shuffle(all(sounds));
    for (auto & s : sounds) {
        println(s);
    }
    shuffle(all(pairs));
    for (auto & p : pairs) {
        println(p.first, p.second);
    }

    vector <vector <int>> reqs;
    int count = 0;
    if (BD_T[gr]) {
        for (int len = MAX_LEN_T[gr]; len > 0 && count < MAX_Q[gr]; --len) {
            for (int len2 = MAX_LEN_T[gr]; len2 >= len && count < MAX_Q[gr]; --len2) {
                int a = MAX_LEN_T[gr] - len + 1, b = MAX_LEN_T[gr], c = MAX_LEN_T[gr] - len2 + 1, d = MAX_LEN_T[gr];
                reqs.push_back({a, b, c, d});
                ++count;
            }
        }
    } else if (AC_1[gr]) {
        for (int len = MAX_LEN_T[gr]; len > 0 && count < MAX_Q[gr]; --len) {
            for (int len2 = MAX_LEN_T[gr]; len2 >= len && count < MAX_Q[gr]; --len2) {
                int a = 1, b = len, c = 1, d = len2;
                reqs.push_back({a, b, c, d});
                ++count;
            }
        }
    } else {
        for (int len = MAX_LEN_T[gr]; len > 0 && count < MAX_Q[gr]; --len) {
            for (int a = 1; a + len - 1 <= MAX_LEN_T[gr] && count < MAX_Q[gr]; ++a) {
                for (int len2 = MAX_LEN_T[gr]; len2 >= len && count < MAX_Q[gr]; --len2) {
                    for (int c = a + 1; c + len2 - 1 <= MAX_LEN_T[gr] && count < MAX_Q[gr]; ++c) {
                        int b = a + len - 1, d = c + len2 - 1;
                        reqs.push_back({a, b, c, d});
                        ++count;
                    }
                }
            }
        }
    }
    println(count);
    for (auto & req : reqs) {
        println(req);
    }
}
