#include "testlib.h"

#define all(a) (a).begin(), (a).end()
#define repeat(a) for (int i_step = 0; i_step < a; ++i_step)
 
using namespace std;

/*
gen max time test for group "gr"
if many_s = 1 -> n is large
else -> n is small
if type_req = 1 -> all requests are 1, |t|, 1, |t|
else if type_req = 2 -> 3 types of requests alternate
else if type_req = 3 -> all queries are different, but substrings are as long as possible
*/

const int GROUPS = 10;
const int MAX_LEN_T[GROUPS + 1] = {500'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 6000, 200'000, 500'000};
const int MAX_S[GROUPS + 1] = {1'000'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 200'000, 400'000, 1'000'000};
const int MAX_Q[GROUPS + 1] = {300'000, 500, 6000, 200'000, 200'000, 200'000, 200'000, 6000, 6000, 200'000, 300'000};
const bool BD_T[GROUPS + 1] = {0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0};
const bool AC_1[GROUPS + 1] = {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0};

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int gr = opt<int>("gr");
    int many_s = opt<int>("many_s");
    int type_req = opt<int>("type_req");
    int center = opt<int>("center");

    string t;
    for (int i = 0; i < MAX_LEN_T[gr]; ++i) {
        t.push_back('a');
    }
    println(t);

    vector <string> sounds;
    if (many_s) {
        int S = 0;
        for (int len = 2; S + len <= MAX_S[gr]; ++len) {
            for (int i = 1; i < 25 && S + len <= MAX_S[gr]; ++i) {
                string s;
                if (center) {
                    repeat(len / 2) {
                        s.push_back('a');
                    }
                    s.push_back((char)('a' + i));
                    repeat((len - 1) / 2) {
                        s.push_back('a');
                    }
                } else {
                    repeat(len - 1) {
                        s.push_back('a');
                    }
                    s.push_back((char)('a' + i));
                }
                sounds.push_back(s);
                S += len;
            }
        }
        int rem = MAX_S[gr] - S;
        if (rem > 1) {
            string s;
            if (center) {
                repeat(rem / 2) {
                    s.push_back('a');
                }
                s.push_back('z');
                repeat((rem - 1) / 2) {
                    s.push_back('a');
                }
            } else {
                repeat(rem - 1) {
                    s.push_back('a');
                }
                s.push_back('z');
            }
            sounds.push_back(s);
            S += rem;
        }
    } else {
        string s;
        if (center) {
            repeat(MAX_S[gr] / 2) {
                s.push_back('a');
            }
            s.push_back('z');
            repeat((MAX_S[gr] - 1) / 2) {
                s.push_back('a');
            }
        } else {
            repeat(MAX_S[gr] - 1) {
                s.push_back('a');
            }
            s.push_back('z');
        }
        sounds.push_back(s);
    }

    int n = (int)sounds.size();

    vector <pair <int, int>> pairs;
    for (int i = 1; i <= n + 26 && (int)pairs.size() < n + 25; ++i) {
        for (int j = i + 1; j <= n + 26 && (int)pairs.size() < n + 25; ++j) {
            if (rnd.next(0, 1)) {
                pairs.push_back({j, i});
            } else {
                pairs.push_back({i, j});
            }
        }
    }
    int k = (int)pairs.size();

    println(n, k);
    shuffle(all(sounds));
    for (auto & s : sounds) {
        println(s);
    }
    shuffle(all(pairs));
    for (auto & p : pairs) {
        println(p.first, p.second);
    }

    if (type_req == 3) {
        vector <vector <int>> reqs;
        int count = 0;
        if (BD_T[gr]) {
            for (int len = MAX_LEN_T[gr]; len > 0 && count < MAX_Q[gr]; --len) {
                for (int len2 = MAX_LEN_T[gr]; len2 >= len && count < MAX_Q[gr]; --len2) {
                    int a = MAX_LEN_T[gr] - len + 1, b = MAX_LEN_T[gr], c = MAX_LEN_T[gr] - len2 + 1, d = MAX_LEN_T[gr];
                    reqs.push_back({a, b, c, d});
                    ++count;
                }
            }
        } else if (AC_1[gr]) {
            for (int len = MAX_LEN_T[gr]; len > 0 && count < MAX_Q[gr]; --len) {
                for (int len2 = MAX_LEN_T[gr]; len2 >= len && count < MAX_Q[gr]; --len2) {
                    int a = 1, b = len, c = 1, d = len2;
                    reqs.push_back({a, b, c, d});
                    ++count;
                }
            }
        } else {
            for (int len = MAX_LEN_T[gr]; len > 0 && count < MAX_Q[gr]; --len) {
                for (int a = 1; a + len - 1 <= MAX_LEN_T[gr] && count < MAX_Q[gr]; ++a) {
                    for (int len2 = MAX_LEN_T[gr]; len2 >= len && count < MAX_Q[gr]; --len2) {
                        for (int c = a + 1; c + len2 - 1 <= MAX_LEN_T[gr] && count < MAX_Q[gr]; ++c) {
                            int b = a + len - 1, d = c + len2 - 1;
                            reqs.push_back({a, b, c, d});
                            ++count;
                        }
                    }
                }
            }
        }
        println(count);
        for (auto & req : reqs) {
            println(req);
        }
    } else {
        println(MAX_Q[gr]);
        for (int i = 0; i < MAX_Q[gr]; ++i) {
            if (type_req == 1) {
                    println(1, MAX_LEN_T[gr], 1, MAX_LEN_T[gr]);
            } else if (type_req == 2) {
                if (i % 3 == 0 && !AC_1[gr] && !BD_T[gr]) {
                    if (rnd.next(0, 1)) {
                        println(1, MAX_LEN_T[gr] - 1, 2, MAX_LEN_T[gr]);
                    } else {
                        println(2, MAX_LEN_T[gr], 1, MAX_LEN_T[gr] - 1);
                    }
                } else if (i % 3 == 1 && !AC_1[gr]) {
                    if (rnd.next(0, 1)) {
                        println(1, MAX_LEN_T[gr], 2, MAX_LEN_T[gr]);
                    } else {
                        println(2, MAX_LEN_T[gr], 1, MAX_LEN_T[gr]);
                    }
                } else if (i % 3 == 2 && !BD_T[gr]) {
                    if (rnd.next(0, 1)) {
                        println(1, MAX_LEN_T[gr] - 1, 1, MAX_LEN_T[gr]);
                    } else {
                        println(1, MAX_LEN_T[gr], 1, MAX_LEN_T[gr] - 1);
                    }
                } else {
                    println(1, MAX_LEN_T[gr], 1, MAX_LEN_T[gr]);
                }
            }
        }
    }
}
