#include "testlib.h"
 
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define repeat(a) for (int i_step = 0; i_step < a; ++i_step)
 
using namespace std;
 
/*
gen test with max block - substr(0, max_blk)
In block - some substrings are sounds
in each substrings some substring are sounds too
*/
 
const int GROUPS = 10;
const int MAX_LEN_T[GROUPS + 1] = {500'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 6000, 200'000, 500'000};
const int MAX_S[GROUPS + 1] = {1'000'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 200'000, 400'000, 1'000'000};
const int MAX_Q[GROUPS + 1] = {300'000, 500, 6000, 200'000, 200'000, 200'000, 200'000, 6000, 6000, 200'000, 300'000};
const bool BD_T[GROUPS + 1] = {0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0};
const bool AC_1[GROUPS + 1] = {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0};

int get_id(int x, vector <int> & dsu) {
    if (dsu[x] == x) return x;
    else return dsu[x] = get_id(dsu[x], dsu);
}
 
int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int group = opt<int>("gr");
    int min_blk = opt<int>("min_blk");
    int max_blk = opt<int>("max_blk");
 
    string t = "";
    repeat(MAX_LEN_T[group]) {
        t.push_back('a' + rnd.next(0, 25));
    }
 
    map <string, int> id;
    map <string, int> pos_t;

    map <int, vector <string>> pos_strings;
 
    for (char x = 'a'; x <= 'z'; ++x) {
        id[string{x}] = x - 'a' + 1;
    }
 
    vector <string> sounds;
 
    int S = 0;
 
    vector <pair <int, int>> pairs;
 
    vector <vector <int>> req;
 
    sounds.push_back(t.substr(0, max_blk));
    id[sounds.back()] = (int)sounds.size() + 26;
    pos_t[sounds.back()] = 0;
    S += sounds.back().size();

    vector <int> interesting_pos;

    int pointer = 0;
    while (pointer < sounds.size()) {
        string s = sounds[pointer];

        int i = 0;
        while (i + min_blk < s.size()) {
            int step = rnd.next(min_blk, min((int)s.size() - 1, (int)s.size() - i));
            if (step + S > MAX_S[group] || id[s.substr(i, step)] != 0) {
                break;
            }
            S += step;
            sounds.push_back(s.substr(i, step));
            id[s.substr(i, step)] = (int)sounds.size() + 26;
            pos_t[s.substr(i, step)] = pos_t[s] + i;
            pos_strings[pos_t[s] + i].push_back(s.substr(i, step));
            i += step;
            interesting_pos.push_back(pos_t[s] + i - 1);
        }

        ++pointer;
    }

    for (auto & p : pos_strings) {
        sort(rall(p.second));
    }

    for (int i = 0; i < MAX_Q[group] && i < interesting_pos.size(); ++i) {
        int pos = interesting_pos[i];
        vector <int> id1;
        int j = 0;
        while (j <= pos) {
            int ind = 0;
            while (ind < pos_strings[j].size() && j + pos_strings[j][ind].size() > pos + 1) {
                ++ind;
            }
            
            if (ind == pos_strings[j].size()) {
                id1.push_back(id[t.substr(j, 1)]);
                ++j;
            } else {
                id1.push_back(id[pos_strings[j][ind]]);
                j += pos_strings[j][ind].size();
            }
        }

        pairs.push_back({id[sounds[0]], id1[0]});
        for (j = 1; j < id1.size(); ++j) {
            pairs.push_back({id1[j], id[t.substr(sounds[0].size() + j - 1, 1)]});
        }

        req.push_back({1, pos + 1, 1, (int)sounds[0].size() + (int)id1.size() - 1});
    }
    
    while(req.size() < MAX_Q[group]) {
        int b = rnd.next(1, (int)t.size());
        int d = rnd.next(1, (int)t.size());
        req.push_back({1, b, 1, d});
    }
 
    println(t);
    
    int n = sounds.size();
    vector <pair <int, int>> input_pairs;
    vector <int> dsu(n + 27);
    for (int i = 0; i <= n + 26; ++i) {
        dsu[i] = i;
    }
 
    for (auto p : pairs) {
        int a = get_id(p.first, dsu);
        int b = get_id(p.second, dsu);
 
        if (a != b) {
            input_pairs.push_back(p);
            if (rnd.next(0, 1)) {
                dsu[a] = b;
            } else {
                dsu[b] = a;
            }
        }
    }
 
    println(n, input_pairs.size());
    for (auto & s : sounds) {
        println(s);
    }
    shuffle(all(input_pairs));
    for (auto & p : input_pairs) {
        println(p.first, p.second);
    }
    
    println(req.size());
    shuffle(all(req));
    for (auto & v : req) {
        println(v);
    }
}
