#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;

using ll = long long;

const int GROUPS = 10;
const int MAX_LEN_T[GROUPS + 1] = {500'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 6000, 200'000, 500'000};
const int MAX_S[GROUPS + 1] = {1'000'000, 500, 6000, 6000, 200'000, 6000, 500, 6000, 200'000, 400'000, 1'000'000};
const int MAX_Q[GROUPS + 1] = {300'000, 500, 6000, 200'000, 200'000, 200'000, 200'000, 6000, 6000, 200'000, 300'000};
const bool BD_T[GROUPS + 1] = {0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0};
const bool AC_1[GROUPS + 1] = {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0};

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    int group = validator.group().empty() ? 0 : atoi(validator.group().c_str());

    ensuref(group <= GROUPS, "The group number must not exceed %d", GROUPS);

    string t = inf.readString("[a-z]{1, "+to_string(MAX_LEN_T[group])+"}", "t");

    int n = inf.readInt(0, MAX_S[group] / 2, "n");
    inf.readSpace();
    int k = inf.readInt(0, n + 25, "k");
    inf.readEoln();

    int S = 0;
    set <string> used_sounds;
    for (int i = 0; i < n; ++i) {
        string s_i = inf.readString("[a-z]{2, "+to_string(MAX_S[group])+"}", "s_i");
        
        ensuref(used_sounds.find(s_i) == used_sounds.end(), "The set of sounds must consist of different strings");
        used_sounds.insert(s_i);
        
        S += int(s_i.size());
        ensuref(S <= MAX_S[group], "The sum of the lengths of the sounds must not exceed %d", MAX_S[group]);
    }

    set <pair<int, int>> used_pairs;
    for (int i = 0; i < k; ++i) {
        int x_i = inf.readInt(1, n + 26, "x_i");
        inf.readSpace();
        int y_i = inf.readInt(1, n + 26, "y_i");
        inf.readEoln();

        ensuref(x_i != y_i, "Sound numbers must be different");
        
        if (x_i > y_i) {
            swap(x_i, y_i);
        }
        ensuref(used_pairs.find({x_i, y_i}) == used_pairs.end(), "Each pair of sounds must occur no more than once");
        used_pairs.insert({x_i, y_i});
    }

    int q = inf.readInt(1, MAX_Q[group], "q");
    inf.readEoln();

    for (int i = 0; i < q; ++i) {
        int a_i = inf.readInt(1, int(t.size()), "a_i");
        inf.readSpace();
        int b_i = inf.readInt(a_i, int(t.size()), "b_i");
        inf.readSpace();
        int c_i = inf.readInt(1, int(t.size()), "c_i");
        inf.readSpace();
        int d_i = inf.readInt(c_i, int(t.size()), "d_i");
        inf.readEoln();

        if (BD_T[group]) {
            ensuref(b_i == d_i && b_i == int(t.size()), "b_i and d_i must be equal %d", int(t.size()));
        }
        if (AC_1[group]) {
            ensuref(a_i == c_i && a_i == 1, "a_i and c_i must be equal 1");
        }
    }
    inf.readEof();
}
