//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,avx,sse2,sse")

#include <iostream>
#include <vector>
#include <map>
#include <cstdint>
#include <cassert>
#include <algorithm>
#include <queue>
#include <set>
#include <random>
#include <unordered_map>
#include <array>
#include <random>
#include <ctime>

using namespace std;
using ull = unsigned long long;
const int P = 300137;
const int MOD = 1e9 + 7;
struct Hash {
    ull h1;
    int h2;

    Hash() : h1(0), h2(0) {}
    Hash(int x) : h1(x), h2((x % MOD + MOD) % MOD) {}
    Hash(ull h1, int h2) : h1(h1), h2(h2) {}

    friend Hash operator+(const Hash& a, const Hash& b) {
        return {a.h1 + b.h1, (a.h2 + b.h2) % MOD};
    }

    friend Hash operator-(const Hash& a, const Hash& b) {
        return {a.h1 - b.h1, (a.h2 - b.h2 + MOD) % MOD};
    }

    friend Hash operator*(const Hash& a, const Hash& b) {
        return {a.h1 * b.h1, (int)((a.h2 * 1ll * b.h2) % MOD)};
    }

    Hash& operator+=(const Hash& other) {
        h1 += other.h1;
        h2 = (h2 + other.h2) % MOD;
        return *this;
    }

    Hash& operator-=(const Hash& other) {
        h1 -= other.h1;
        h2 = (h2 - other.h2 + MOD) % MOD;
        return *this;
    }

    Hash& operator*=(const Hash& other) {
        h1 *= other.h1;
        h2 = (h2 * 1ll * other.h2) % MOD;
        return *this;
    }

    friend bool operator==(const Hash& a, const Hash& b) {
        return a.h1 == b.h1 && a.h2 == b.h2;
    }
};

vector<int> val;
map<string, int> map_val;
string t;
vector<string> a;
const int SZ = 3;
vector<vector<pair<int, int>>> to;

struct node {
    node* to[26];
    node* go[26];
    node* suf_link = nullptr;
    node* parent = nullptr;
    char how;
    int len = 0;
    int idx = -1;

    node() {
        fill(begin(to), end(to), nullptr);
        fill(begin(go), end(go), nullptr);
    }
};

node* root;
void add(string& s, int idx) {
    node* v = root;
    for (char c : s) {
        if (!v->to[c - 'a']) {
            v->to[c - 'a'] = new node();
            v->to[c - 'a']->parent = v;
            v->to[c - 'a']->how = c;
        }
        v = v->to[c - 'a'];
    }
    v->len = s.size();
    v->idx = idx;
}

node* get_suf_link(node*);

node* get_go(node* v, char c) {
    if (v->go[c - 'a'])
        return v->go[c - 'a'];
    if (v->to[c - 'a'])
        return v->go[c - 'a'] = v->to[c - 'a'];
    if (v == root)
        return v->go[c - 'a'] = root;
    node* tmp = get_suf_link(v);
    node* lol = get_go(tmp, c);
    return v->go[c - 'a'] = lol;
}

node* get_suf_link(node* v) {
    if (v->suf_link)
        return v->suf_link;
    if (v == root || v->parent == root)
        return v->suf_link = root;
    node* tmp = get_suf_link(v->parent);
    node* lol = get_go(tmp, v->how);
    return v->suf_link = lol;
}

void delete_tree(node* v) {
    for (auto u : v->to) {
        if (u)
            delete_tree(u);
    }
    delete v;
}

void fill_to() {
    root = new node();
    for (int i = 0; i < a.size(); ++i) {
        auto s = a[i];
        reverse(s.begin(), s.end());
        add(s, i);
    }
    node* v = root;
    int sz = t.size();
    for (int i = sz - 1; i >= 0; --i) {
        v = get_go(v, t[i]);
        auto w = v;
        while (w != root) {
            if (w->idx >= 0)
                to[i].emplace_back(i + w->len, w->idx);
            w = get_suf_link(w);
        }
        reverse(to[i].begin(), to[i].end());
    }
    delete_tree(root);
}

void solve() {
    cin >> t;
    int n, k; cin >> n >> k;
    n += 26;
    a.resize(n);
    val.assign(n, 0);
    to.resize(t.size());
    for (int i = 26; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < 26; ++i) {
        a[i] = string(1, 'a' + i);
    }
    fill_to();
    vector<vector<int>> g(n);
    for (int i = 0; i < k; ++i) {
        int x, y; cin >> x >> y;
        --x, --y;
        g[x].push_back(y);
        g[y].push_back(x);
    }

    int nxt = 0;
    auto dfs = [&](int v, auto&& self) -> void {
        val[v] = nxt;
        map_val[a[v]] = nxt;
        for (int to : g[v]) {
            if (val[to] == 0) {
                self(to, self);
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        if (!val[i]) {
            ++nxt;
            dfs(i, dfs);
        }
    }
    int q; cin >> q;
    vector<vector<pair<int, int>>> rights(t.size());
    vector<Hash> ans(q * 2);
    vector<pair<int, int>> queries(q * 2);
    for (int i = 0; i < q * 2; ++i) {
        int l, r; cin >> l >> r;
        --l, --r;
        queries[i] = {l, r};
        rights[l].emplace_back(r, i);
    }
    if (t.size() <= 6000) {
        for (int l = 0; l < t.size(); ++l) {
            vector<Hash> prec(t.size());
            auto local_dfs = [&](Hash acc, int i, int bord, auto&& self) -> void {
                for (int w = 0; w < to[i].size(); ++w) {
                    auto [j, idx] = to[i][w];
                    if (j <= bord + 1) {
                        prec[j - 1] = acc * P + val[idx];
                    }
                    if (j > bord) continue;
                    int nxt = 1e9;
                    if (w + 1 < to[i].size()) nxt = to[i][w + 1].first;
                    self(acc * P + val[idx], j, min(bord, nxt - 1), self);
                }
            };
            local_dfs(0, l, (int)t.size() - 1, local_dfs);
            for (auto [r, i] : rights[l]) {
                ans[i] = prec[r];
            }
        }
    } else {
        for (auto[l, r] : queries) {
            int i = l;
            Hash res = 0;
            while (i <= r) {
                int w = lower_bound(to[i].begin(), to[i].end(), make_pair(r + 2, -1)) - to[i].begin() - 1;
                assert(w >= 0);
                res *= P;
                res += val[to[i][w].second];
                i = to[i][w].first;
            }
            ans.push_back(res);
        }
    }

    for (int i = 0; i < q; ++i) {
        if (ans[i * 2] == ans[i * 2 + 1]) cout << "Yes\n";
        else cout << "No\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    //freopen("javacert.in", "r", stdin);
    //freopen("javacert.out", "w", stdout);

    solve();
}
