#include <bits/stdc++.h>
// data structures
#include <unordered_map>
#include <unordered_set>
// data abbreviations
#define umap unordered_map
#define uset unordered_set
// other abbreviations
#define newl '\n'
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define repeat(a) for (int i_step = 0; i_step < a; ++i_step)
 
using namespace std;
 
// random
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
 
// namespace
using ld = double;
using ll = long long;
using pdd = pair<ld, ld>;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
 
// constants
const ll INF = LLONG_MAX / 2ll;
const ll INFi = INT_MAX / 2ll;
const ll mod = 1e9 + 7;
const ld eps = 1e-11;
 
// {{BEGIN OF THE WORKSPACE}}
 
void solve() {
    string t;
    cin >> t;
    
    int n, k;
    cin >> n >> k; n += 26;
    vector <string> sounds(n);
    for (int i = 0; i < 26; ++i) {
        sounds[i] = "a";
        sounds[i][0] += i;
    }
    for (int i = 26; i < n; ++i) {
        cin >> sounds[i];
    }
 
    vector<vector<int>> gr_sounds(n);
 
    repeat(k) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        gr_sounds[x].pb(y);
        gr_sounds[y].pb(x);
    }
 
    vector<int> id(n, -1);
    ll p = 0;
    for (int i = 0; i < n; ++i) {
        if (id[i] != -1)
            continue;
        queue<int> bfs;
        bfs.push(i);
        id[i] = p;
        while (!bfs.empty()) {
            int x = bfs.front();
            bfs.pop();
            for (auto& to : gr_sounds[x]) {
                if (id[to] != -1)
                    continue;
                id[to] = p;
                bfs.push(to);
            }
        }
        ++p;
    }

    map <vector <int>, int> ans;
 
    int q;
    cin >> q;
    repeat(q) {
        int a, b, c, d;
        cin >> a >> b >> c >> d; --a, --c;

        if (ans[{a, b, c, d}] != 0) {
            if (ans[{a, b, c, d}] == 1) {
                cout << "Yes" << newl;
            } else {
                cout << "No" << newl;
            }
            continue;
        }
 
        vector <int> id1, id2;
 
        int id_max;
        for (int i = a; i < b; i += sounds[id_max].size()) {
            id_max = -1;
            for (int ind = 0; ind < sounds.size(); ++ind) {
                if (b - i < (int)sounds[ind].size())
                    continue;
                int ok = 1;
                for (int j = 0; j < (int)sounds[ind].size(); ++j) {
                    if (t[i + j] != sounds[ind][j]) {
                        ok = 0;
                        break;
                    }
                }
                if (ok && (id_max == -1 || sounds[id_max].size() < sounds[ind].size())) {
                    id_max = ind;
                }
            }
            id1.push_back(id[id_max]);
        }
 
        for (int i = c; i < d; i += sounds[id_max].size()) {
            id_max = -1;
            for (int ind = 0; ind < sounds.size(); ++ind) {
                if (d - i < (int)sounds[ind].size())
                    continue;
                bool ok = 1;
                for (int j = 0; j < (int)sounds[ind].size(); ++j) {
                    if (t[i + j] != sounds[ind][j]) {
                        ok = 0;
                        break;
                    }
                }
                if (ok && (id_max == -1 || sounds[id_max].size() < sounds[ind].size())) {
                    id_max = ind;
                }
            }
            id2.push_back(id[id_max]);
        }
 
        bool ok = 1;
        for (int i = 0; i < (int)min(id1.size(), id2.size()); ++i) {
            if (id1[i] != id2[i]) {
                ok = 0;
                break;
            }
        }
 
        if (ok && id1.size() == id2.size()) {
            cout << "Yes" << newl;
            ans[{a, b, c, d}] = 1;
        } else {
            cout << "No" << newl;
            ans[{a, b, c, d}] = 2;
        }
    }
}
 
// {{END OF THE WORKSPACE}}
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
 
    int t = 1;
    // cin >> t;
    repeat(t) {
        solve();
    }
}
