#include <bits/stdc++.h>
// data structures
#include <cassert>
#include <unordered_map>
#include <unordered_set>
// data abbreviations
#define umap unordered_map
#define uset unordered_set
// other abbreviations
#define newl '\n'
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define repeat(a) for (int i_step = 0; i_step < a; ++i_step)
 
using namespace std;
 
// random
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
 
// namespace
using ld = double;
using ll = long long;
using pdd = pair<ld, ld>;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
 
// constants
const ll INF = LLONG_MAX / 2ll;
const ll INFi = INT_MAX / 2ll;
const ll mod = 1e9 + 7;
const ld eps = 1e-11;
 
// {{BEGIN OF THE WORKSPACE}}
 
struct node {
    int id = -1;
    node* suff_link = nullptr;
    node* terminal_suff_link = nullptr;
    node* link[26] = {nullptr};
};
 
bool cmp_string(pair<string, int>& a, pair<string, int>& b) {
    return a.first.size() < b.first.size() || a.first.size() == b.first.size() && a.first < b.first;
}
 
void solve() {
    string t;
    cin >> t;
 
    int n, k;
    cin >> n >> k;
    n += 26;
    vector<string> sounds(n);
    for (int i = 0; i < 26; ++i) {
        sounds[i] = "a";
        sounds[i][0] += i;
    }
    for (int i = 26; i < n; ++i) {
        cin >> sounds[i];
    }
 
    vector<vector<int>> gr_sounds(n);
 
    repeat(k) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        gr_sounds[x].pb(y);
        gr_sounds[y].pb(x);
    }
 
    vector<int> id(n, -1);
    ll p = 0;
    for (int i = 0; i < n; ++i) {
        if (id[i] != -1)
            continue;
        queue<int> bfs;
        bfs.push(i);
        id[i] = p;
        while (!bfs.empty()) {
            int x = bfs.front();
            bfs.pop();
            for (auto& to : gr_sounds[x]) {
                if (id[to] != -1)
                    continue;
                id[to] = p;
                bfs.push(to);
            }
        }
        ++p;
    }
 
    auto root = new node();
 
    for (int i = 0; i < n; ++i) {
        auto temp = root;
        for (int j = (int)sounds[i].size() - 1; j >= 0; --j) {
            if (temp->link[sounds[i][j] - 'a'] == nullptr) {
                temp->link[sounds[i][j] - 'a'] = new node();
            }
            temp = temp->link[sounds[i][j] - 'a'];
        }
        temp->id = i;
    }
 
    queue<pair<node*, pair<node*, int>>> bfs;
    bfs.push({root, {nullptr, -1}});
    while (!bfs.empty()) {
        auto mas = bfs.front();
        bfs.pop();
        int c = mas.second.second;
        auto x = mas.first, temp = mas.second.first;
        while (temp != nullptr && temp->link[c] == nullptr) {
            temp = temp->suff_link;
        }
 
        if (temp == nullptr) {
            x->suff_link = root;
            if (x == root)
                root->suff_link = nullptr;
        } else {
            x->suff_link = temp->link[c];
        }
 
        if (x->id != -1) {
            x->terminal_suff_link = x;
        } else if (x->suff_link != nullptr) {
            x->terminal_suff_link = x->suff_link->terminal_suff_link;
        } else {
            x->terminal_suff_link = nullptr;
        }
 
        for (int i = 0; i < 26; ++i) {
            if (x->link[i] != nullptr)
                bfs.push({x->link[i], {x->suff_link, i}});
        }
    }
 
    vector<int> jump_t(t.size());
 
    auto cur = root;
    for (int i = (int)t.size() - 1; i >= 0; --i) {
        int c = t[i] - 'a';
        while (cur != nullptr && cur->link[c] == nullptr) {
            cur = cur->suff_link;
        }
 
        if (cur == nullptr) {
            cur = root;
        } else {
            cur = cur->link[c];
        }
 
        jump_t[i] = cur->terminal_suff_link->id;
    }
 
    vector<vector<int>> jump_sounds(n);
    for (int i = 26; i < n; ++i) {
        jump_sounds[i].resize((int)sounds[i].size() - 1);
        auto cur = root;
        for (int j = (int)sounds[i].size() - 2; j >= 0; --j) {
            int c = sounds[i][j] - 'a';
            while (cur != nullptr && cur->link[c] == nullptr) {
                cur = cur->suff_link;
            }
 
            if (cur == nullptr) {
                cur = root;
            } else {
                cur = cur->link[c];
            }
 
            jump_sounds[i][j] = cur->terminal_suff_link->id;
        }
    }
 
    vector<pair<string, int>> sort_sounds(n);
    for (int i = 0; i < n; ++i) {
        sort_sounds[i] = {sounds[i], i};
    }
    sort(all(sort_sounds), cmp_string);
 
    vector<ll> pw_p(t.size(), 1);
    for (int i = 1; i < (int)t.size(); ++i) {
        pw_p[i] = pw_p[i - 1] * p % mod;
    }
 
    vector<vector<pll>> dp(n);
    for (auto& [s, i] : sort_sounds) {
        dp[i].resize(s.size());
        pll pref = {0, 0};
        for (int j = 0; j < (int)s.size() - 1; j += (int)sounds[jump_sounds[i][j]].size()) {
            for (int x = 0; x < (int)sounds[jump_sounds[i][j]].size(); ++x) {
                dp[i][j + x].first = pref.first + dp[jump_sounds[i][j]][x].first;
                dp[i][j + x].second = (pref.second * pw_p[dp[jump_sounds[i][j]][x].first] % mod + dp[jump_sounds[i][j]][x].second) % mod;
            }
            pref = dp[i][j + (int)sounds[jump_sounds[i][j]].size() - 1];
        }
        dp[i].back() = {1, id[i]};
    }
 
    vector<ll> pw_2(30, 1);
    int log_t = -1;
    for (int i = 1; i < 30; ++i) {
        pw_2[i] = pw_2[i - 1] * 2ll;
        if (pw_2[i] > (ll)t.size() && log_t == -1) {
            log_t = i;
        }
    }
 
    vector<vector<pll>> sparce_table(log_t, vector<pll>(t.size()));
    for (int i = 0; i < (int)t.size(); ++i) {
        sparce_table[0][i] = {(ll)sounds[jump_t[i]].size(), id[jump_t[i]]};
    }
    for (int x = 1; x < log_t; ++x) {
        for (int i = 0; i < (int)t.size(); ++i) {
            sparce_table[x][i] = sparce_table[x - 1][i];
            if (i + sparce_table[x - 1][i].first < int(t.size())) {
                sparce_table[x][i].first += sparce_table[x - 1][i + sparce_table[x - 1][i].first].first;
                sparce_table[x][i].second =
                    (sparce_table[x][i].second * pw_p[pw_2[x - 1]] % mod + sparce_table[x - 1][i + sparce_table[x - 1][i].first].second) % mod;
            }
        }
    }
 
    int q;
    cin >> q;
    repeat(q) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
 
        pll hash1 = {0, 0};
        int x = a;

        int cnt = 0;
        repeat(18) {
            for (int i = log_t - 1; i >= 0; --i) {
                if (x + sparce_table[i][x].first <= b) {
                    hash1.first += pw_2[i];
                    hash1.second = (hash1.second * pw_p[pw_2[i]] % mod + sparce_table[i][x].second) % mod;
                    x += sparce_table[i][x].first;
                    ++cnt;
                }
            }
        }

        hash1 = {0, 0};
        x = a;
        for (int i = log_t - 1; i >= 0; --i) {
            if (x + sparce_table[i][x].first <= b) {
                hash1.first += pw_2[i];
                hash1.second = (hash1.second * pw_p[pw_2[i]] % mod + sparce_table[i][x].second) % mod;
                x += sparce_table[i][x].first;
            }
        }
        hash1.first += dp[jump_t[x]][b - x].first;
        hash1.second = (hash1.second * pw_p[dp[jump_t[x]][b - x].first] % mod + dp[jump_t[x]][b - x].second) % mod;
 
        pll hash2 = {0, 0};
        x = c;

        int cnt2 = 0;
        repeat(18) {
            for (int i = log_t - 1; i >= 0; --i) {
                if (x + sparce_table[i][x].first <= d) {
                    hash2.first += pw_2[i];
                    hash2.second = (hash2.second * pw_p[pw_2[i]] % mod + sparce_table[i][x].second) % mod;
                    x += sparce_table[i][x].first;
                    ++cnt2;
                }
            }
        }

        hash2 = {0, 0};
        x = c;
        for (int i = log_t - 1; i >= 0; --i) {
            if (x + sparce_table[i][x].first <= d) {
                hash2.first += pw_2[i];
                hash2.second = (hash2.second * pw_p[pw_2[i]] % mod + sparce_table[i][x].second) % mod;
                x += sparce_table[i][x].first;
            }
        }
        hash2.first += dp[jump_t[x]][d - x].first;
        hash2.second = (hash2.second * pw_p[dp[jump_t[x]][d - x].first] % mod + dp[jump_t[x]][d - x].second) % mod;
 
        if (hash1 == hash2) {
            cout << "Yes" << newl;
        } else {
            cout << "No" << newl;
        }

        if (cnt + cnt2 == 0) {
            assert("Bad!!!");
        }
    }
}
 
// {{END OF THE WORKSPACE}}
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
 
    int t = 1;
    // cin >> t;
    repeat(t) {
        solve();
    }
}
