#include <bits/stdc++.h>
// data structures
#include <unordered_map>
#include <unordered_set>
// data abbreviations
#define umap unordered_map
#define uset unordered_set
// other abbreviations
#define newl '\n'
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define repeat(a) for (int i_step = 0; i_step < a; ++i_step)
 
using namespace std;
 
// random
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
 
// namespace
using ld = double;
using ll = long long;
using pdd = pair<ld, ld>;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
 
// constants
const ll INF = LLONG_MAX / 2ll;
const ll INFi = INT_MAX / 2ll;
const ll mod = 1e9 + 7;
const ld eps = 1e-11;
 
// {{BEGIN OF THE WORKSPACE}}
 
bool cmp_string(pair<string, int>& a, pair<string, int>& b) {
    return a.first.size() < b.first.size() || a.first.size() == b.first.size() && a.first < b.first;
}
 
void solve() {
    string t;
    cin >> t;
 
    int n, k;
    cin >> n >> k;
    n += 26;
    vector<string> sounds(n);
    for (int i = 0; i < 26; ++i) {
        sounds[i] = "a";
        sounds[i][0] += i;
    }
    for (int i = 26; i < n; ++i) {
        cin >> sounds[i];
    }
 
    vector<vector<int>> gr_sounds(n);
 
    repeat(k) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        gr_sounds[x].pb(y);
        gr_sounds[y].pb(x);
    }
 
    vector<int> id(n, -1);
    ll p = 0;
    for (int i = 0; i < n; ++i) {
        if (id[i] != -1)
            continue;
        queue<int> bfs;
        bfs.push(i);
        id[i] = p;
        while (!bfs.empty()) {
            int x = bfs.front();
            bfs.pop();
            for (auto& to : gr_sounds[x]) {
                if (id[to] != -1)
                    continue;
                id[to] = p;
                bfs.push(to);
            }
        }
        ++p;
    }
 
    vector<int> jump_t(t.size(), -1);
 
    for (int i = 0; i < t.size(); ++i) {
        for (int j = 0; j < sounds.size(); ++j) {
            int ok = 1;
            for (int l = 0; l < sounds[j].size(); ++l) {
                if (i + l >= t.size() || t[i + l] != sounds[j][l]) {
                    ok = 0;
                    break;
                }
            }
            if (ok && (jump_t[i] == -1 || sounds[jump_t[i]].size() < sounds[j].size())) {
                jump_t[i] = j;
            }
        }
    }
 
    vector<vector<int>> jump_sounds(n);
    for (int i = 26; i < n; ++i) {
        jump_sounds[i].resize(sounds[i].size() - 1, - 1);
        for (int pos = 0; pos < sounds[i].size() - 1; ++pos) {
            for (int j = 0; j < sounds.size(); ++j) {
                int ok = 1;
                for (int l = 0; l < sounds[j].size(); ++l) {
                    if (pos + l >= sounds[i].size() - 1 || sounds[i][pos + l] != sounds[j][l]) {
                        ok = 0;
                        break;
                    }
                }
                if (ok && (jump_sounds[i][pos] == -1 || sounds[jump_sounds[i][pos]].size() < sounds[j].size())) {
                    jump_sounds[i][pos] = j;
                }
            }
        }
    }
 
    vector<pair<string, int>> sort_sounds(n);
    for (int i = 0; i < n; ++i) {
        sort_sounds[i] = {sounds[i], i};
    }
    sort(all(sort_sounds), cmp_string);
 
    vector<ll> pw_p(t.size(), 1);
    for (int i = 1; i < (int)t.size(); ++i) {
        pw_p[i] = pw_p[i - 1] * p % mod;
    }
 
    vector<vector<pll>> dp(n);
    for (auto& [s, i] : sort_sounds) {
        dp[i].resize(s.size());
        pll pref = {0, 0};
        for (int j = 0; j < (int)s.size() - 1; j += (int)sounds[jump_sounds[i][j]].size()) {
            for (int x = 0; x < (int)sounds[jump_sounds[i][j]].size(); ++x) {
                dp[i][j + x].first = pref.first + dp[jump_sounds[i][j]][x].first;
                dp[i][j + x].second = (pref.second * pw_p[dp[jump_sounds[i][j]][x].first] % mod + dp[jump_sounds[i][j]][x].second) % mod;
            }
            pref = dp[i][j + (int)sounds[jump_sounds[i][j]].size() - 1];
        }
        dp[i].back() = {1, id[i]};
    }
 
    vector<ll> pw_2(30, 1);
    int log_t = -1;
    for (int i = 1; i < 30; ++i) {
        pw_2[i] = pw_2[i - 1] * 2ll;
        if (pw_2[i] > (ll)t.size() && log_t == -1) {
            log_t = i;
        }
    }
 
    int q;
    cin >> q;
    repeat(q) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
 
        pll hash1 = {0, 0};
        int x = a;
        while (x + (int)sounds[jump_t[x]].size() <= b) {
            hash1.first += 1;
            hash1.second = (hash1.second * p % mod + id[jump_t[x]]) % mod;
            x += (int)sounds[jump_t[x]].size();
        }
        hash1.first += dp[jump_t[x]][b - x].first;
        hash1.second = (hash1.second * pw_p[dp[jump_t[x]][b - x].first] % mod + dp[jump_t[x]][b - x].second) % mod;
 
        pll hash2 = {0, 0};
        x = c;
        while (x + (int)sounds[jump_t[x]].size() <= d) {
            hash2.first += 1;
            hash2.second = (hash2.second * p % mod + id[jump_t[x]]) % mod;
            x += (int)sounds[jump_t[x]].size();
        }
        hash2.first += dp[jump_t[x]][d - x].first;
        hash2.second = (hash2.second * pw_p[dp[jump_t[x]][d - x].first] % mod + dp[jump_t[x]][d - x].second) % mod;
 
        if (hash1 == hash2) {
            cout << "Yes" << newl;
        } else {
            cout << "No" << newl;
        }
    }
}
 
// {{END OF THE WORKSPACE}}
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
 
    int t = 1;
    // cin >> t;
    repeat(t) {
        solve();
    }
}
